var proxyButton = {

    m_toolbutton: false,
    m_wasinited: false,
    m_commonprefs: false,
    m_pb_prefs: false,
    m_pb_logger: false,
    m_pb_rObserver: {
        observe : function(subject, topic, data) { proxyButton.setButtonFromPreference(); }
    },
    m_pb_pbi: false,

    switchProxy: function() {
        this.log(1, 'called switchProxy()');
        if (!this.m_wasinited || !this.m_toolbutton) {
            this.init();
        }
    
        var nCurProxyType = this.m_commonprefs.getIntPref("network.proxy.type");
        if (nCurProxyType == 0) {
            this.setManual();
        } else {
            this.setDirect();
        }
    },

    init: function() {
        if (!this.m_pb_logger) {
            try {
                var logMngr = Components.classes["@mozmonkey.com/debuglogger/manager;1"].
                        getService(Components.interfaces.nsIDebugLoggerManager); 
                this.m_pb_logger = logMngr.registerLogger("proxybutton");
            } catch (exErr) {
                this.m_pb_logger = false;
            }
        }
        
        this.log(1, 'called init()');
        if (!this.m_commonprefs) {
            this.initPrefObjects();
        }
        this.log(1, 'checking prefs for existance');
        this.checkPreferencesExist();
        if (!this.m_toolbutton) {
            this.log(1, 'looking for button element');
            if (document.getElementById("proxybutton-button")) {
                this.m_toolbutton = document.getElementById("proxybutton-button");
            } else if (document.getElementById("proxybutton-button-sb")) {
                this.m_toolbutton = document.getElementById("proxybutton-button-sb");
            } else if (document.getElementById("proxybutton-button-tb")) {
                this.m_toolbutton = document.getElementById("proxybutton-button-tb");
            } else {
                this.m_toolbutton = document.getElementById("proxybutton-button-tb-msg");
            }
        } else {
            this.log(1, 'skipping button element search');
        }
        if (!this.m_wasinited) {
            this.log(1, 'initializing observer');
            this.log(1, 'getting service');
            var prefService = Components.classes["@mozilla.org/preferences-service;1"].
                getService(Components.interfaces.nsIPrefService);
            this.log(1, 'getting branch');
            var rBranch = prefService.getBranch("network.");
            this.log(1, 'quering interface');
            this.m_pb_pbi = rBranch.QueryInterface(Components.interfaces.nsIPrefBranchInternal);
            this.log(1, 'adding observer');
            this.m_pb_pbi.addObserver("proxy", this.m_pb_rObserver, false);
            
            this.m_wasinited = true;
        } else {
            this.log(1, 'skipping observers init');
        }
        
        this.log(1, 'setting from prefs');
        this.setButtonFromPreference();
        this.log(1, 'init completed');
    },

    destroy: function() {
        this.log(1, 'Calling destroy');
        this.m_pb_pbi.removeObserver("proxy", this.m_pb_rObserver);
    },

    setButtonFromPreference: function() {
        var nCurProxyType = this.m_commonprefs.getIntPref("network.proxy.type");
        if (nCurProxyType == 0) {
            this.changeImage(0);
        } else {
            this.changeImage(1);
        }
    
    },

    setDirect: function() {
        this.log(1, 'called setDirect()');
        this.m_commonprefs.setIntPref("network.proxy.type", 0);
        var swOff = this.m_pb_prefs.getBoolPref('launch_swoff');
        if (this.m_pb_prefs.getBoolPref('launch_swoff')) {
            var runcmd;
            if (this.m_pb_prefs.getBoolPref('launch_swoff_same')) {
                runcmd = this.m_pb_prefs.getCharPref('launch_swon_cmd');
            } else {
                runcmd = this.m_pb_prefs.getCharPref('launch_swoff_cmd');
            }
            this.startApp(runcmd);
        }
    },

    changeImage: function(nToType) {
        var sPrefix;
    
        this.log(1, 'called changeImage()');
        if (nToType==0) {
            this.m_toolbutton.setAttribute('pbstatus', 'off');
            this.m_toolbutton.setAttribute('tooltiptext', 'Turn proxy on');
        } else {
            this.m_toolbutton.setAttribute('pbstatus', 'on');
            this.m_toolbutton.setAttribute('tooltiptext', 'Turn proxy off');
        }
    },

    setManual: function() {
        this.log(1, 'called setManual()');
        var proxyCurType = this.m_pb_prefs.getIntPref('proxytype');
        this.m_commonprefs.setIntPref("network.proxy.type", proxyCurType);
        
        if (this.m_pb_prefs.getBoolPref('launch_swon')) {
            var runcmd = this.m_pb_prefs.getCharPref('launch_swon_cmd');
            this.startApp(runcmd);
        }
        
        if (proxyCurType == 2 && this.m_pb_prefs.getBoolPref('autoreload')) {
            // Autoreload enabled and autoproxy turned on - do it
            this.autoReloadProxy();
        }
    },

    autoReloadProxy: function() {
        this.log(1, 'called autoReloadProxy()');
        
        var autoURL = this.m_commonprefs.getCharPref('network.proxy.autoconfig_url');
        var nsIProtocolProxyService = Components.interfaces.nsIProtocolProxyService;
        var kPROTPROX_CID = '{e9b301c0-e0e4-11D3-a1a8-0050041caf44}';
        
        var pps = Components.classesByID[kPROTPROX_CID].getService(nsIProtocolProxyService);
        pps.configureFromPAC(autoURL);
    },

    initPrefObjects: function() {
        this.m_commonprefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
    
        this.m_pb_prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
        this.m_pb_prefs = this.m_pb_prefs.getBranch("extensions.proxybutton.");
    },

    initPreferences: function(doc) {
        var pb_pref_radio = doc.getElementById('pb_nProxyType');
        var pb_pref_reload = doc.getElementById('pb_bReload');
        if (!this.m_commonprefs) {
            this.initPrefObjects();
        }
        this.checkPreferencesExist();
        
        pb_pref_radio.selectedIndex = this.m_pb_prefs.getIntPref('proxytype')-1;
        pb_pref_reload.checked = this.m_pb_prefs.getBoolPref('autoreload');
        
        doc.getElementById('pb_bLaunchOn').checked = this.m_pb_prefs.getBoolPref('launch_swon');
        doc.getElementById('pb_sLaunchOn').value = this.m_pb_prefs.getCharPref('launch_swon_cmd');
        this.modifyLaunchOn(doc, this.m_pb_prefs.getBoolPref('launch_swon'));
        doc.getElementById('pb_bLaunchOff').checked = this.m_pb_prefs.getBoolPref('launch_swoff');
        doc.getElementById('pb_nLaunchOff').selectedIndex = !this.m_pb_prefs.getBoolPref('launch_swoff_same')*1;
        doc.getElementById('pb_sLaunchOff').value = this.m_pb_prefs.getCharPref('launch_swoff_cmd');
        this.modifyLaunchOff(doc, this.m_pb_prefs.getBoolPref('launch_swoff'));
    },

    modifyLaunchOn: function(doc, isEnabled) {
        doc.getElementById('pb_sLaunchOn').disabled = !isEnabled;
        doc.getElementById('pb_labLaunchOn').disabled = !isEnabled;
        doc.getElementById('pb_butLaunchOn').disabled = !isEnabled;
    },

    modifyLaunchOff: function(doc, isEnabled) {
        doc.getElementById('pb_radOffType1').disabled = !isEnabled;
        doc.getElementById('pb_radOffType2').disabled = !isEnabled;
        doc.getElementById('pb_radOffLabel1').disabled = !isEnabled;
        doc.getElementById('pb_radOffLabel2').disabled = !isEnabled;
        doc.getElementById('pb_butOff').disabled = !isEnabled;
        doc.getElementById('pb_sLaunchOff').disabled = !isEnabled;
    },

    savePreferences: function(doc) {
        this.m_pb_prefs.setIntPref('proxytype', doc.getElementById('pb_nProxyType').selectedItem.value);
        this.m_pb_prefs.setBoolPref('autoreload', doc.getElementById('pb_bReload').checked);
        
        this.m_pb_prefs.setBoolPref('launch_swon', doc.getElementById('pb_bLaunchOn').checked);
        this.m_pb_prefs.setCharPref('launch_swon_cmd', doc.getElementById('pb_sLaunchOn').value);
    
        this.m_pb_prefs.setBoolPref('launch_swoff', doc.getElementById('pb_bLaunchOff').checked);
        this.m_pb_prefs.setBoolPref('launch_swoff_same', doc.getElementById('pb_nLaunchOff').selectedItem.value);
        this.m_pb_prefs.setCharPref('launch_swoff_cmd', doc.getElementById('pb_sLaunchOff').value);
    },

    checkPreferencesExist: function() {
        try {
            this.m_pb_prefs.getIntPref('proxytype');
        } catch (rErr) {
            // Got exception - it seems that there's no such preference. Smash it in.
            this.m_pb_prefs.setIntPref('proxytype', 1);
        }
    
        try {
            this.m_commonprefs.getCharPref('keyconfig.main.xxx_key__ProxyButton Switch');
        } catch (rErr) {
            // Got exception - it seems that there's no such preference. Smash it in.
            this.m_commonprefs.setCharPref('keyconfig.main.xxx_key__ProxyButton Switch', '!][][][proxybutton_switchProxy();][');
        }
    
        try {
            this.m_pb_prefs.getBoolPref('autoreload');
        } catch (rErr) {
            // Got exception - it seems that there's no such preference. Smash it in.
            this.m_pb_prefs.setBoolPref('autoreload', 0);
        }
        
        try {
            this.m_pb_prefs.getBoolPref('launch_swon');
        } catch (rErr) {
            // Got exception so we assume that we don't have preferences for "External program launch" at all
            // so let's add all of them
            this.m_pb_prefs.setBoolPref('launch_swon', 0);
            this.m_pb_prefs.setCharPref('launch_swon_cmd', '');
            
            this.m_pb_prefs.setBoolPref('launch_swoff', 0);
            this.m_pb_prefs.setBoolPref('launch_swoff_same', 1);
            this.m_pb_prefs.setCharPref('launch_swoff_cmd', '');
        }
    },

    log: function(nLevel, sMsg) {
        if (this.m_pb_logger) {
            var rDate = new Date();
            this.m_pb_logger.log(nLevel, rDate.getTime()+': '+sMsg);
        }
    },

    chooseApp: function(targetElm) {
        const nsIFilePicker = Components.interfaces.nsIFilePicker;
        var gPrefApplicationsBundle = document.getElementById('pb_prefStrings');
        var filePicker = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
        if (filePicker) {
            const FP = Components.interfaces.nsIFilePicker
            var windowTitle = gPrefApplicationsBundle.getString("prefWindowTitle");
            var programsFilter = gPrefApplicationsBundle.getString("prefFilterName");
            
            filePicker.init(window, windowTitle, FP.modeOpen);
            if (navigator.platform == "Win32") {
                filePicker.appendFilter(programsFilter, "*.exe; *.com");
            } else {
                filePicker.appendFilters(FP.filterAll);
            }
            
            var filePicked = filePicker.show();
            if (filePicked == nsIFilePicker.returnOK && filePicker.file) {
                var file = filePicker.file.QueryInterface(Components.interfaces.nsILocalFile);
                targetElm.value = file.path;
                targetElm.select();
            }
        }
    },

    startApp: function(fileName) {
        try {
            var lfile = Components.classes['@mozilla.org/file/local;1'].createInstance(Components.interfaces.nsILocalFile);
            lfile.initWithPath(fileName);
    
            if (lfile.isFile() && lfile.isExecutable()) {
                try {
                    var process = Components.classes['@mozilla.org/process/util;1'].createInstance(Components.interfaces.nsIProcess);
                    process.init(lfile);
                    var res = process.run(false, null, 0);
                } catch (e) {
                    // huh?
                }
            }
        }
        catch(e) {
            // huh?
        }
        //return data;
    }

};
